AM261x MCU+ SDK: APIs for MPU Firewall

| AM261x MCU+ SDK 26.00.00 |

Files | Data Structures | Functions | Enumerations
APIs for MPU Firewall
APIs for SOC Specific Device Drivers

## Introduction

This module contains APIs to program the MPU Firewall module.

## Files
file | mpu_firewall/v0/mpu_firewall.h
| MPU Firewall Driver API/interface file.

## Data Structures
struct | Firewall_Target
| MPU Firewall Target. More...
struct | MPU_FIREWALL_Config
| MPU Firewall Parameters. More...
struct | MPU_FIREWALL_RegionParams
| MPU Region Parameters. More...

## Functions
Fwl_Return_t | MPU_FIREWALL_getRegion (MPU_FIREWALL_RegionParams *mpuParams)
| Retrieves the start and end addresses and the permission attributes of a given region in a given firewall. More...
Fwl_Return_t | MPU_FIREWALL_getFirewallConfig (uint32_t firewallId, MPU_FIREWALL_Config **firewallConfig)
| Function to get parameters associated to a MPU firewall. More...
Fwl_Return_t | MPU_FIREWALL_readFaultAddress (uint32_t firewallId, uint32_t *faultAddress)
| Function to read the fault address that created the firewall violation. More...
Fwl_Return_t | MPU_FIREWALL_readFaultStatus (uint32_t firewallId, uint32_t *faultStatus)
| Function to read the fault status register. It contains information on the kind of firewall violation that had occurred. More...
Fwl_Return_t | MPU_FIREWALL_getInterruptStatus (uint32_t firewallId, uint32_t *interruptStatus)
| Function to read interrupt status. More...

## Enumerations
enum | Fwl_Return_t { FWL_DRV_RETURN_SUCCESS = 0xBA14D51BU, FWL_DRV_RETURN_FAILURE = 0xAADF4AFAU }
| Firewall Driver Error code. More...

## Enumeration Type Documentation

## ◆ Fwl_Return_t

enum Fwl_Return_t

Firewall Driver Error code.

The enumeration describes all the possible return and error codes which the Firewall Driver can return

Enumerator
FWL_DRV_RETURN_SUCCESS | Success/pass return code
FWL_DRV_RETURN_FAILURE | General or unspecified failure/error

## Function Documentation

## ◆ MPU_FIREWALL_getRegion()

Fwl_Return_t MPU_FIREWALL_getRegion | ( | MPU_FIREWALL_RegionParams * | mpuParams | ) |

Retrieves the start and end addresses and the permission attributes of a given region in a given firewall.

Parameters

  mpuParams | Structure containing all region configuration parameters.

Returns
  FWL_DRV_RETURN_SUCCESS if the region configuration is successfully fetched; else FWL_DRV_RETURN_FAILURE

## ◆ MPU_FIREWALL_getFirewallConfig()

Fwl_Return_t MPU_FIREWALL_getFirewallConfig | ( | uint32_t | firewallId,
|  | MPU_FIREWALL_Config ** | firewallConfig
| ) |  |

Function to get parameters associated to a MPU firewall.

Parameters

  firewallId | Firewall ID.
  firewallConfig | Structure to save mpu firewall configuration.

Returns
  FWL_DRV_RETURN_SUCCESS on successful config read; else FWL_DRV_RETURN_FAILURE

## ◆ MPU_FIREWALL_readFaultAddress()

Fwl_Return_t MPU_FIREWALL_readFaultAddress | ( | uint32_t | firewallId,
|  | uint32_t * | faultAddress
| ) |  |

Function to read the fault address that created the firewall violation.

Parameters

  firewallId | MPU Firewall Id
  faultAddress | pointer to the faultAddress to be populated

Returns
  FWL_DRV_RETURN_SUCCESS on successful fault address read; else FWL_DRV_RETURN_FAILURE

## ◆ MPU_FIREWALL_readFaultStatus()

Fwl_Return_t MPU_FIREWALL_readFaultStatus | ( | uint32_t | firewallId,
|  | uint32_t * | faultStatus
| ) |  |

Function to read the fault status register. It contains information on the kind of firewall violation that had occurred.

Parameters

  firewallId | MPU Firewall Id
  faultStatus | pointer to the faultStatus to be populated

Returns
  FWL_DRV_RETURN_SUCCESS on successful fault status read; else FWL_DRV_RETURN_FAILURE

## ◆ MPU_FIREWALL_getInterruptStatus()

Fwl_Return_t MPU_FIREWALL_getInterruptStatus | ( | uint32_t | firewallId,
|  | uint32_t * | interruptStatus
| ) |  |

Function to read interrupt status.

Parameters

  firewallId | MPU Firewall Id
  interruptStatus | pointer to the interruptStatus to be populated

Returns
  FWL_DRV_RETURN_SUCCESS on successful interrupt status read; else FWL_DRV_RETURN_FAILURE